#include "mcs.h"

/* ============================== main ======================== */
int
main(int args, char *argv[])
{
   long int test;          // var temp para revisar validez del argumento <port>
   
   size_t charcount;       // cuenta caracteres leidos o escritos por read, write, send y recv
   int    f_ret;           // recuerda valor de retorno de algunas funciones
   int    cid;             // client_id
   int    _cid;            // valor anterior de cid
   int    i;
   
   pthread_t tid;          // identificador de hilo (poca importancia en este programa)
   
   struct timeval tv;      // usado para darle un timeout a select()
   
   switch (args)
   {
      case 1:
         port = 0xFFFF;
         autoport = 1;
         break;
      
      case 2:
         test = strtol(argv[1], NULL, 0);
         if (errno == EINVAL)
         {
            printf("Argumento invalido: port\n");
            exit(1);
         }
         if (errno == ERANGE || test > 0xFFFF || test < 0)
         {
            printf("numero invalido de puerto: %ld", test);
            exit(1);
         }
         port = (int)test;
         break;
      
      default:
         printf("Uso: %s [port]\n", argv[0]);
         exit(1);
   }
   
   atexit(close_ritual);
   signal(SIGINT, sig_handler);
   
   /* preparativos para select() */
   FD_ZERO(&_atento);
   tv.tv_sec = 1;
   tv.tv_usec = 0;
   
   /* crea el hilo que recibira a los clientes */
   if (pthread_create(&tid, NULL, mayordomo, NULL))
   {
      perror("pthread_create");
      exit(1);
   }
   
   _cid = 0;
   do
   {
      /* espera que haya algun cliente conectado */
      while (clientcount <= 0) // aqui no necesita mutex
         sleep(1);
      
      pthread_mutex_lock(&mutex);
      atento = _atento;
      pthread_mutex_unlock(&mutex);
      f_ret = select(sockMayor+1, &atento, NULL, NULL, &tv);
      if (f_ret == 0)
         continue;
         // select salio por timeout, sirve para incluir rapidamente a los clientes que lleguen
      
      /* revisa los fd_socket como un buffer circular (para ser justo) */
      cid = _cid;
      do
      {
         if (client_sock[cid] > 2 && FD_ISSET(client_sock[cid], &atento))
         {
            _cid = (cid + 1) % MAXCLIENTS;
            break;
         }
         cid = (cid + 1) % MAXCLIENTS;
      }while(cid != _cid);
      
      if (cid == _cid) // ¿dio la vuelta completa?
         continue;
      
      /* pone nombre de usuario al principio del mensaje */
      strcpy(buffer, client_name[cid]);
      strcat(buffer, POSTNAME);
      nameoffset = strlen(buffer);
      
      /* lee socket y copia a buffer */
      charcount = recv(client_sock[cid], (buffer+nameoffset), BUFSIZE-nameoffset, 0);
      // si hay una funcion para vaciar el buffer TCP del socket, ponerla AQUI
      switch (charcount)
      {
         case 0: // cliente se desconecto
            printf("leido EOF en socket, %s se desconecto\n", inet_ntoa(client_ent[cid].sin_addr));
            pthread_mutex_lock(&mutex);
            FD_CLR(client_sock[cid], &_atento);
            clientcount--;
            pthread_mutex_unlock(&mutex);
            close(client_sock[cid]);
            client_sock[cid] = 0; // asi no lo envia al que se desconecto
            strcpy(buffer+nameoffset-POSTSIZE, " se desconecto\n");
            send2all(buffer, strlen(buffer));
            printf("hay %d clientes conectados\n", clientcount);
            continue;
         
         case -1: // error de lectura
            printf("error de lectura de socket, fin de la comunicacion\n");
            pthread_mutex_lock(&mutex);
            FD_CLR(client_sock[cid], &_atento);
            clientcount--;
            pthread_mutex_unlock(&mutex);
            close(client_sock[cid]);
            client_sock[cid] = 0; // asi no lo envia al que se desconecto
            strcpy(buffer+nameoffset-POSTSIZE, " fue desconectado\n");
            send2all(buffer, strlen(buffer));
            printf("hay %d clientes conecados\n", clientcount);
            continue;
      }
      
      /* envia buffer a cada cliente */
      send2all(buffer, charcount+nameoffset);
   }while(1);
   
   //salir:
   //close(listen_sock);
   //close(client_sock);
   
   return 0;
}

/* ========================== FUNCIONES ========================== */

void *
mayordomo(void *nah)
{
   int puesto = 0; // indica que elemento de client_sock[] estamos actualmente viendo (se recorre de manera circular)
   struct sockaddr_in server_ent;
   
   size_t charcount; // cuenta los caracteres leidos o escritos por recv, send, read o write
   
   server_ent.sin_family = AF_INET;
   server_ent.sin_addr.s_addr = htonl(INADDR_ANY);
   
   listen_sock = socket(AF_INET, SOCK_STREAM, 0);
   
   again:
   server_ent.sin_port   = htons(port);
   if ( bind(listen_sock, (struct sockaddr *)&server_ent, sizeof(struct sockaddr_in)) )
   {
      if (autoport == 0)
      {
         perror("bind");
         printf("pruebe con otro puerto\n");
         close(listen_sock);
         exit(1);
      }
      
      if (errno == EADDRINUSE) // puerto ocupado
      {
         port--;
         if (port >= 1024)
            goto again;
         else
         {
            perror("bind");
            printf("el programa no pudo encontrar un puerto disponible\n");
            close(listen_sock);
            exit(1);
         }
      }
   }
   printf("Escuchando puerto: %d\n", port);
   
   do
   {
      /* aqui se bloquea el hilo 'mayordomo' mientras el otro sigue recibiendo los mensajes */
      listen(listen_sock, 5);
      
      /* servidor lleno (si solo queda el puesto para avisar que esta lleno) */
      if (clientcount == MAXCLIENTS)
      {
         client_sock[MAXCLIENTS] = accept(listen_sock, (struct sockaddr *)&client_ent[MAXCLIENTS], &len);
         send(client_sock[MAXCLIENTS], FULLSRVMSG, strlen(FULLSRVMSG), 0);
         close(client_sock[MAXCLIENTS]);
         continue;
      }
      
      /* busca un puesto desocupado */
      while(client_sock[puesto] != 0)
         puesto = (puesto + 1) % MAXCLIENTS;
      
      client_sock[puesto] = accept(listen_sock, (struct sockaddr *)&client_ent[puesto], &len);
      if (client_sock[puesto] <= 2)
      {  // por si algo raro pasa
         printf("accept asigno socket_fd <= 2\n");
         exit(1);
      }
      
      /* registra nombre del cliente */
      /* OJO, si el nombre es muy largo hay que consumirlo entero; no interfiere con el 
         otro hilo pues el socket del cliente aun no esta registrado para select() */
      charcount = recv(client_sock[puesto], client_name[puesto], NAMESIZE, 0);
      // si hay una funcion para vaciar el buffer de recv TCP del socket, ponerla AQUI
      if (charcount < 0)
      {
         printf("cliente %s no pudo enviar su nombre: no se conecto\n", inet_ntoa(client_ent[puesto].sin_addr));
         close(client_sock[puesto]);
         client_sock[puesto] = 0;
         continue;
      }
      client_name[puesto][charcount] = 0; // finaliza string con '\0'
      
      /* avisa a todos la llegada del nuevo cliente */
      strcpy(buffer, client_name[puesto]);
      strcat(buffer, " acaba de conectarse\n");
      send2all(buffer, strlen(buffer));
      
      /* ve cual es el socket con fd mas alto, para decirle a select() */
      if (client_sock[puesto] > sockMayor)
         sockMayor = client_sock[puesto];
      
      /* agrega el nuevo cliente a la lista de descriptores que se pasa a select() */
      pthread_mutex_lock(&mutex);
      FD_SET(client_sock[puesto], &_atento);
      clientcount++;
      pthread_mutex_unlock(&mutex);
      printf("Conexion de cliente %s aceptada\n", inet_ntoa(client_ent[puesto].sin_addr));
      printf("hay %d clientes conectados\n", clientcount);
      printf("(Servidor escuchando puerto %d)\n", port);
      
   }while(1);
}

int
send2all(const char *buffer, int n)
{
   int i;
   
   for (i=0 ; i<MAXCLIENTS ; i++)
   {
      if (client_sock[i] < 2)
         continue; // puesto vacio
      
      if (send(client_sock[i], buffer, n, 0) < 0)
      {
         perror("send");
         break;
      }
   }
   
   return 0;
}

void
sig_handler(int sign)
{
   exit(1);
}

void
close_ritual(void)
{
   int i;
   
   for (i=0 ; i<MAXCLIENTS ; i++)
   {
      if (client_sock[i] != 0)
         close(client_sock[i]);
      
      if (listen_sock != 0)
         close(listen_sock);
   }
   
   printf("Todo bien cerrado\n");
   return;
}
