#ifndef __MCS_H__
#define __MCS_H__

#include <sys/types.h>
#include <netdb.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/select.h>
#include <sys/time.h>
#include <pthread.h>
#include <signal.h>

#define BUFSIZE    256       // largo del buffer de mensajes
#define MAXCLIENTS   4       // numero maximo de clientes
#define NAMESIZE    32       // largo maximo del nombres de cliente
#define POSTNAME " dice:\n"  // lo que se agrega entre el nombre y el mensaje
#define POSTSIZE     7       // carateres usados por POSTNAME
#define FULLSRVMSG "SERVIDOR LLENO\n" // mensaje de servidor lleno

/* =================== VARIABLES GLOBALES =================== */

/* lleva la cuenta de cuantos clientes estan conectados */
int  clientcount = 0;

/* arreglo de descriptores, uno para cada cliente (asignado por accept());
   si vale 0, es un puesto desocupado 
   el "+1" es un puesto mas, pero solo para avisar que el servidor esta lleno */
int  client_sock[MAXCLIENTS +1];

/* socket que recibe las peticiones de conexion */
int listen_sock = 0;

/* arreglo de strings, guarda los nombres de los clientes */
char client_name[MAXCLIENTS][NAMESIZE];

/* indica cuantos caracteres usa el nombre + el POSTNAME */
int  nameoffset;

char buffer[BUFSIZE]; // buffer para los mensajes

struct sockaddr_in client_ent[MAXCLIENTS +1];
socklen_t          len = sizeof(struct sockaddr_in);

int port;

/* vector de descriptores que se pasa a select() */
fd_set atento;
fd_set _atento; // una copia del vector 'atento'

/* recuerda el mayor fd registrado en 'atento', para decirle a select() */
int    sockMayor = 0;

/* mutex para protejer a '_atento' y a 'clientcount', que son modificados por 2 hilos */
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

/* sirve para decirle a mayordomo que el debe asignar el puerto */
int autoport = 0;



/* ============================ PROTOTIPOS =================== */

/* hilo que atiende la llegada de los clientes */
void *mayordomo(void *);

/* envia el mensaje 'char *' de largo 'int' a todos los clientes conectados */
int send2all(const char *, int);

/* por si hacen Control+C */
void sig_handler(int);

/* cierra todos los descriptores antes de salir */
void close_ritual(void);

#endif
